CLOSEDIR(P)

NAME
closedir - close a directory stream

SYNOPSIS

#include <dirent.h>

int closedir(DIR *dirp);

DESCRIPTION

The closedir() function shall close the directory stream referred to by the argument dirp. Upon return, the value of dirp may no longer point to an accessible object of the type DIR. If a file descriptor is used to implement type DIR, that file descriptor shall be closed.

RETURN VALUE

Upon successful completion, closedir() shall return 0; otherwise, -1 shall be returned and errno set to indicate the error.

ERRORS

The closedir() function may fail if:

EBADF
    The dirp argument does not refer to an open directory stream.

EINTR
    The closedir() function was interrupted by a signal.

The following sections are informative.

EXAMPLES

  Closing a Directory Stream

The following program fragment demonstrates how the closedir() function is used.

    ...
        DIR *dir;
        struct dirent *dp;
    ...
        if ((dir = opendir (".")) == NULL) {
    ...
        }

        while ((dp = readdir (dir)) != NULL) {
    ...
        }

        closedir(dir);
    ...

APPLICATION USAGE

None.

RATIONALE

None.

FUTURE DIRECTIONS

None.

SEE ALSO

opendir() , the Base Definitions volume of IEEE Std 1003.1-2001, <dirent.h>

COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .